<?php
/**
 * @package	Hikashop Captcha integration Plugin
 * @version	1.0.1
 * @author	HikaShop
 * @copyright	(C) 2010-2023 HIKARI SOFTWARE. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
include_once(JPATH_ROOT.'/administrator/components/com_hikashop/pluginCompat.php');
if(!class_exists('hikashopJoomlaPlugin')) return;
class plgSystemHikashopcaptcha extends hikashopJoomlaPlugin
{
	public $components = array('com_hikashop','com_hikamarket');
	public $captchaAdded = null;
	public $params = null;
	public $errorCodes = null;

	function __construct(&$subject, $config) {
		parent::__construct($subject, $config);
		$this->_init();
	}

	function _init() {
		if(isset($this->params))
			return;

		$plugin = JPluginHelper::getPlugin('system', 'hikashopcaptcha');
		if(version_compare(JVERSION,'2.5','<')) {
			jimport('joomla.html.parameter');
			$this->params = new JParameter($plugin->params);
		} else {
			$this->params = new JRegistry($plugin->params);
		}
		if(HIKASHOP_J50 && !class_exists('JCaptcha')) {
			class_alias( '\Joomla\CMS\Captcha\Captcha', 'JCaptcha');
		}
	}

	function onHikashopBeforeDisplayView(&$view) {
		$user = JFactory::getUser();
		if (!$user->guest) {
			return true;
		}

		$viewName = $view->getName();
		if($viewName == 'checkout')
			$this->_handleNewCheckout($view);
		if($viewName == 'user' && $view->getLayout() == 'form')
			$this->_handleNewRegForm($view);

		if($viewName == 'product' && $view->getLayout() == 'contact')
			$this->_handleContactForm($view);
		if($viewName == 'order' && $view->getLayout() == 'contact')
			$this->_handleContactForm($view);
	}

	function onHikamarketBeforeDisplayView(&$view) {
		$viewName = $view->getName();
		if($viewName == 'vendormarket' && $view->getLayout() == 'form')
			$this->_handleHikaMarketRegForm($view);
	}
	function _handleHikaMarketRegForm(&$view) {
		$config = hikashop_config();
		$this->captchaAdded = true;

		$user = JFactory::getUser();
		if(!$user->guest)
			return;

		if(!isset($view->extraData))
			$view->extraData = new stdClass();

		switch($this->params->get('fieldafter','password')) {
			case 'email':
				$after = 'top';
				break;
			case 'end':
				$after = 'bottom';
				break;
			default:
				$after = 'middle';
				break;
		}
		$subText = $this->params->get('captchatext');
		if(empty($subText)){
			$subText = JText::_('Captcha');
		}

		$html = $this->getHTML();
		if(empty($html))
			return;
		$html = '
			<dt class="hikamarket_' . $view->form_type . '_captcha_line">
				<label id="captchamsg" class="captchamsg" title="">
					'.$subText.'*
				</label>
			</dt>
			<dd class="hikamarket_' . $view->form_type . '_captcha_line">
				'.$html.'
			</dd>';

		if(!isset($view->extraData->$after))
			$view->extraData->$after = array();
		$view->extraData->{$after}[] = $html;
	}
	function getHTML() {
		$captcha_plugin = JFactory::getConfig()->get('captcha');
		if ($captcha_plugin == '0') {
			return '';
		}

		$captcha = JCaptcha::getInstance($captcha_plugin);
  		$field_id = 'hikashop_captcha';
		$result = $captcha->display($field_id, $field_id, $field_id);
		return $result;
	}

	function _handleNewRegForm(&$view) {
		$config = hikashop_config();
		$this->captchaAdded = true;

		if(!isset($view->extraData))
			$view->extraData = new stdClass();

		switch($this->params->get('fieldafter','password')) {
			case 'email':
				$after = 'top';
				break;
			case 'end':
				$after = 'bottom';
				break;
			default:
				$after = 'middle';
				break;
		}
		$subText = $this->params->get('captchatext');
		if(empty($subText)){
			$subText = JText::_('Captcha');
		}

		$html = $this->getHTML();
		if(empty($html))
			return;

		$html = '
			<div class="hkform-group control-group hikashop_registration_captcha_line" id="hikashop_registration_captcha_line">
				<label id="captchamsg" class="hkc-sm-4 hkcontrol-label" title="">
					'.$subText.'*
				</label>
				<div class="hkc-sm-8">
					'.$html.'
				</div>
			</div>';
		if(!isset($view->extraData->$after))
			$view->extraData->$after = array();
		$view->extraData->{$after}[] = $html;
	}
	function _handleNewCheckout(&$view) {
		$config = hikashop_config();
		if($config->get('checkout_legacy',0))
			return true;

		if(!isset($view->workflow_step) || !isset($view->workflow) || !isset($view->workflow['steps'][$view->workflow_step]['content']))
			return true;

		if(!$this->params->get('registration',1))
			return true;

		if(!isset($view->extraData))
			$view->extraData = array();

		switch($this->params->get('fieldafter','password')) {
			case 'email':
				$after = 'top';
				break;
			case 'end':
				$after = 'bottom';
				break;
			default:
				$after = 'middle';
				break;
		}
		$subText = $this->params->get('captchatext');
		if(empty($subText)){
			$subText = JText::_('Captcha');
		}

		$html = $this->getHTML();
		if(empty($html))
			return;

		$html = '
			<div class="hkform-group control-group hikashop_registration_captcha_line" id="hikashop_registration_captcha_line">
				<label id="captchamsg" class="hkc-sm-4 hkcontrol-label" title="">
					'.$subText.'*
				</label>
				<div class="hkc-sm-8">
					'.$html.'
				</div>
			</div>';
		foreach($view->workflow['steps'][$view->workflow_step]['content'] as $k => $v) {
			if($v['task'] != 'login')
				continue;
			if(!isset($view->extraData[$k]))
				$view->extraData[$k] = new stdClass();
			if(!isset($view->extraData[$k]->$after))
				$view->extraData[$k]->$after = array();

			$view->extraData[$k]->{$after}[] = $html;
		}
	}


	function _handleContactForm(&$view) {
		$this->captchaAdded = true;

		if(!isset($view->extra_data))
			$view->extra_data = array();

		if(!isset($view->extra_data['fields']))
			$view->extra_data['fields'] = array();

		$subText = $this->params->get('captchatext');
		if(empty($subText)){
			$subText = JText::_('Captcha');
		}

		$html = $this->getHTML();
		if(empty($html))
			return;

		$view->extra_data['fields']['captcha']= array(
			'label' => $subText.'*',
			'content' => $html,
		);
	}

	function onBeforeSendContactRequest(&$element,&$send){
		$app = JFactory::getApplication();

		if(version_compare(JVERSION,'4.0','>=') && $app->isClient('administrator'))
			return true;
		if(version_compare(JVERSION,'4.0','<') && $app->isAdmin())
			return true;
		$this->_init();
		if(!$this->params->get('contact',0)){
			return true;
		}
		$send = $this->_checkCaptcha();
		if(!empty($this->errorCodes))
			$app->enqueueMessage($this->errorCodes, 'error');
		return true;
	}

	function onBeforeHikaUserRegistration(&$ret, $input_data, $mode){

		$app = JFactory::getApplication();
		if(version_compare(JVERSION,'4.0','>=')) {
			if($app->isClient('administrator'))
				return true;
		} else {
			if($app->isAdmin())
				return true;
		}

		$option = JFactory::getApplication()->input->get('option');
		$ctrl = JFactory::getApplication()->input->get('ctrl');
		$task = JFactory::getApplication()->input->get('task');

		if ($option=='com_updateme' && $ctrl=='subscription' && $task=='api') return true;

		if ($option=='com_hikashop' && $ctrl=='user' && $task=='guest_register') return true;


		if (!in_array($option,$this->components)) return true;

		$this->_init();
		if(!$this->params->get('registration',1)){
			return true;
		}

		$ret['status'] = $this->_checkCaptcha();
		if(!$ret['status'])
			$ret['messages']['recaptcha'] = array($this->errorCodes, 'error');
	}

	function _checkCaptcha() {
		$user = JFactory::getUser();
		if (!$user->guest) {
			return true;
		}

		$captcha_plugin = JFactory::getConfig()->get('captcha');
		if ($captcha_plugin == '0') {
			return true;
		}

		JPluginHelper::importPlugin('captcha');
		$app = JFactory::getApplication();

		$code = null;
		if(isset($_REQUEST['hikashop_captcha']))
			$code = hikaInput::get()->getString('hikashop_captcha');
		try {
			$captcha = JCaptcha::getInstance($captcha_plugin);
			$result = $captcha->checkAnswer($code);
		} catch(RuntimeException $exception) {
			$errorCodes = $exception->getMessage();
			$this->errorCodes = $errorCodes;
			if(hikaInput::get()->getString('tmpl') == 'raw') {
				$message = [
					'message' => $errorCodes,
					'type'    => 'error',
				];
				$app->getSession()->set('application.queue', array($message));
				hikashop_display($errorCodes, 'error');
				echo '<script>window.location.reload();</script>';
			} else {
				$app->enqueueMessage($errorCodes, 'error');
			}
			return false;
		}
		if(empty($result))
			return false;
		if(is_array($result)) {
			foreach($result as $r) {
				if($r)
					return true;
			}
			return false;
		}
		return $result;
	}

}//endclass
